export function createMemo(fn) {
    const data = $derived(fn());
    return () => data;
}
export function derive(fn) {
    const data = $derived(fn());
    return () => data;
}
export function on() { }
export function createResource(fetcher) {
    const s = $state({ data: null, error: null, isLoading: true });
    const c = (...arg) => {
        s.isLoading = true;
        fetcher(...arg)
            .then((v) => {
            s.data = v;
        })
            .catch((v) => {
            s.error = v;
        })
            .finally(() => {
            s.isLoading = false;
        });
    };
    return [
        () => s.data,
        {
            mutate: (fn) => {
                s.data = typeof fn == 'function' ? fn() : fn;
            },
            refetch: c,
        },
    ];
}
